﻿using Prism.Commands;
using Prism.Mvvm;
using Prism.Regions;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;

namespace ViewDiscovery.ViewModels
{
    public class TileInformation : BindableBase
    {
        #region FIELDS

        private String _description;
        public string Description
        {
            get
            {
                return _description;
            }

            set
            {
                SetProperty(ref _description, value);
            }
        }

        private String _name;
        public String Name
        {
            get
            {
                return _name;
            }
            set
            {
                SetProperty(ref _name, value);
            }
        }

        #endregion

        public TileInformation(String Name, String Description)
        {
            this.Name = Name;
            this.Description = Description;           
        }
    }

    public class GridViewModel : BindableBase
    {

        private ObservableCollection<TileInformation> _tiles;
        public ObservableCollection<TileInformation> Tiles
        {
            get
            {
                return _tiles;
            }
            set
            {
                SetProperty(ref _tiles, value);
            }
        }

        public DelegateCommand AddTileCommand { get; private set; }
        private readonly IRegionManager _regionManager;

        public GridViewModel(IRegionManager regionManager)
        {
            _regionManager = regionManager;

            // Initialize commands
            AddTileCommand = new DelegateCommand(AddTile);

            List<TileInformation> tileList = new List<TileInformation>();

            for (int i = 1; i <= 10; i++)
            {
                String _Name = String.Format("Tile {0}", i);
                String _Description = String.Format("Description for {0}", i);

                tileList.Add(new TileInformation(_Name, _Description));
            }


            _tiles = new ObservableCollection<TileInformation>(tileList);

        }
        private void AddTile()
        {
            String _Name = String.Format("Tile {0}", Tiles.Count+1);
            String _Description = String.Format("Description for {0}", Tiles.Count + 1);

            Tiles.Add(new TileInformation(_Name, _Description));
            
        }
      
       
    }

}
